#         Portable Batch System (PBS) Software License
# 
# Copyright (c) 1999, MRJ Technology Solutions.
# All rights reserved.
# 
# Acknowledgment: The Portable Batch System Software was originally developed
# as a joint project between the Numerical Aerospace Simulation (NAS) Systems
# Division of NASA Ames Research Center and the National Energy Research
# Supercomputer Center (NERSC) of Lawrence Livermore National Laboratory.
# 
# Redistribution of the Portable Batch System Software and use in source
# and binary forms, with or without modification, are permitted provided
# that the following conditions are met:
# 
# - Redistributions of source code must retain the above copyright and
#   acknowledgment notices, this list of conditions and the following
#   disclaimer.
# 
# - Redistributions in binary form must reproduce the above copyright and 
#   acknowledgment notices, this list of conditions and the following
#   disclaimer in the documentation and/or other materials provided with the
#   distribution.
# 
# - All advertising materials mentioning features or use of this software must
#   display the following acknowledgment:
# 
#   This product includes software developed by NASA Ames Research Center,
#   Lawrence Livermore National Laboratory, and MRJ Technology Solutions.
# 
#         DISCLAIMER OF WARRANTY
# 
# THIS SOFTWARE IS PROVIDED BY MRJ TECHNOLOGY SOLUTIONS ("MRJ") "AS IS" WITHOUT 
# WARRANTY OF ANY KIND, AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING,
# BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS
# FOR A PARTICULAR PURPOSE, AND NON-INFRINGEMENT ARE EXPRESSLY DISCLAIMED.
# 
# IN NO EVENT, UNLESS REQUIRED BY APPLICABLE LAW, SHALL MRJ, NASA, NOR
# THE U.S. GOVERNMENT BE LIABLE FOR ANY DIRECT DAMAGES WHATSOEVER,
# NOR ANY INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
# CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
# OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
# USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
# 
# This license will be governed by the laws of the Commonwealth of Virginia,
# without reference to its choice of law rules.
################################################################################
# qdel: defines the layout and functions of the delete job
#       dialog box.
proc qdel {} {
  global jobsSelected qdelv LABELFONT SERVER_HOSTS cmdpath qdelDialogBox \
         activeWindow

  busy_cursor
## Bring up the standard Dialog box ##
  set qdelDialogBox ".delete"
  set dbox [popupDialogBox $qdelDialogBox "Delete Job Dialog"]
  set activeWindow($qdelDialogBox) 1
  set dbox_top    [lindex $dbox 0]
  set dbox_bottom [lindex $dbox 1]

## BOTTOM PART ##
  set cmdButtons \
  [buildCmdButtons $dbox_bottom {{{delete delete} {cancel cancel} {help help}}} x 5m 10 3]

  set cmdFrame  [lindex $cmdButtons 0]
  set cmdDelete [lindex $cmdButtons 1]
  set cmdCancel [lindex $cmdButtons 2]
  set cmdHelp   [lindex $cmdButtons 3]
 
  $cmdDelete configure -command {

    if {[string compare $qdelv(delay) ""] != 0} {
      set exitcode [win_cmdExec $qdelDialogBox \
			"$cmdpath(QDEL) -W $qdelv(delay) $jobsSelected"]
    } else {
      set exitcode [win_cmdExec $qdelDialogBox "$cmdpath(QDEL) $jobsSelected"]
    }
    if {$exitcode == 0} {
      after 500 [list getdata $SERVER_HOSTS 1]
      destroy $qdelDialogBox
    }
  }
  $cmdCancel configure -command [list destroy $qdelDialogBox]
  $cmdHelp configure -command {xpbs_help delete $qdelDialogBox}

## TOP PART ##
  frame $dbox_top.header -height 5m -width 10m
  frame $dbox_top.footer -height 2m -width 10m
  frame $dbox_top.d
  frame $dbox_top.d.e
  frame $dbox_top.c
  frame $dbox_top.c.sp

  label $dbox_top.d.l -font $LABELFONT -text "Delete job(s):"
  set jobidbox [buildFullListbox $dbox_top.d.e 55x3 "" yscroll 0]
  set jobidFrame [lindex $jobidbox 0]
  set jobidField [lindex $jobidbox 3]
  $jobidField configure -relief sunken
  bind_text_readonly $jobidField

  foreach el $jobsSelected {
    $jobidField insert end $el
  }


  label $dbox_top.c.l -font $LABELFONT \
	-text "For running job(s), send kill signal after"

  set spinBox [buildSpinbox $dbox_top.c.sp 4 0-9999 qdelv delay \
		"secs from sending terminate signal."]
  set spinBoxFrame  [lindex $spinBox 0]
  set spinBoxEntry  [lindex $spinBox 1]
  set spinBoxScroll [lindex $spinBox 2]

  set qdelv(delay) ""
  register_default_action $spinBoxEntry $cmdCancel

## ARRANGEMENT ON SCREEN
  pack $dbox_top.c.l -side left -pady 1m -anchor nw
  pack $spinBoxFrame -side right -pady 1m -anchor nw
  pack $dbox_top.d.l $dbox_top.d.e -side left -anchor nw
  pack $dbox_top.header $dbox_top.d $dbox_top.c $dbox_top.footer \
	-anchor nw -side top -pady 2m -padx 10m 

  register_default_action $qdelDialogBox $cmdCancel
  tkwait visibility $qdelDialogBox
  remove_busy_cursor
  catch {tkwait window $qdelDialogBox}
  set activeWindow($qdelDialogBox) 0
  catch {unset qdelv}
}
